package com.sms.controls.client;

public class MaskApply {
    private String unMaskedValue = "";
    
    public String getUnmaskedValue() {
		return unMaskedValue;
	}

	public void setUnmaskedValue(String unmaskedValue) {
		if (unmaskedValue == null) {
			unmaskedValue = "";
		}
		this.unMaskedValue = unmaskedValue;
		this.applyMask();
	}

	private String maskedValue = "";

	public String getMaskedValue() {
		return maskedValue;
	}

    private String mask = "";

	public String getMask() {
		return mask;
	}

	public void setMask(String mask) {
		if (mask == null) {
			mask = "";
		}
		
		this.mask = mask;
		this.applyMask();
	}

	public MaskApply() {
		// TODO Auto-generated constructor stub
	}

	public MaskApply(String mask) {
		this.setMask(mask);
	}
	
    /**
     * Applies the supplied format to the values in the supplied FormatObject
     *  and updates the values in the FormatObject
     * @param format String - the format to be applied to the values in the 
     *      FormatObject
     * @param formatValues FormatObject - the value to be formatted  
     */
    public void applyMask() {
        String unmaskedValue = this.getUnmaskedValue();
        String mask = this.getMask();
        String maskChars = "x,a,9,#,!";
        String newUnmaskedValue = "";
        String maskedValue = "";
        Integer maskPos = -1;
        Integer valuePos = -1;
        String currMaskChar;
        String currValueChar;
        Boolean isInteger;
        
        if (mask != null && !mask.isEmpty()) {
	        while (true) {
	            maskPos = maskPos + 1;
	            valuePos = valuePos + 1;
	            
	            /**
	             * If we have processed all the chars in one or both of the strings
	             * leave.
	             */
	            if (maskPos > mask.length() - 1 || valuePos > unmaskedValue.length() - 1) {
	                break;
	            }
	            
	            currMaskChar = mask.substring(maskPos, maskPos + 1).toLowerCase();
	            currValueChar = unmaskedValue.substring(valuePos, valuePos + 1);
	            isInteger = this.isInteger(currValueChar);
	            
	            if (maskChars.contains(currMaskChar)) {
	                if ("x".equals(currMaskChar)) {
	                    maskedValue = maskedValue.concat(currValueChar);
	                    newUnmaskedValue = newUnmaskedValue.concat(currValueChar);
	                    continue;
	                } 
	                
	                if ("9".equals(currMaskChar) || "#".equals(currMaskChar)) {
	                    if (isInteger) {
	                        maskedValue = maskedValue.concat(currValueChar);
	                        newUnmaskedValue = newUnmaskedValue.concat(currValueChar);
	                    } else {
	                        /**
	                         * If we are looking for a number and do not find one
	                         * we want to stay on the same format char, but move 
	                         * forward on the unformatted unformattedValue.
	                         */
	                        maskPos = maskPos - 1;
	                    }
	                    continue;
	                }
	                
	                if ("a".equals(currMaskChar) || "!".equals(currMaskChar)) {
	                    if (isInteger || " ".equals(currValueChar)) {
	                        /**
	                         * If we are looking for a non-number and non-space, 
	                         * and do not find one we want to stay on the same 
	                         * format char, but move forward on the unformatted value.
	                         */
	                        maskPos = maskPos - 1;                        
	                    } else {
	                        if ("!".equals(currMaskChar)) {
	                            currValueChar = currValueChar.toUpperCase();
	                        }
	                        maskedValue = maskedValue.concat(currValueChar);
	                        newUnmaskedValue = newUnmaskedValue.concat(currValueChar);
	                    }
	                }
	                
	            } else { 
	                if ("/".equals(currMaskChar)) {
	                    maskPos = maskPos + 1;
	                    currMaskChar = mask.substring(maskPos,maskPos + 1);
	                }
	                
//	                maskedValue = maskedValue.concat(mask.substring(maskPos,maskPos + 1));
	                maskedValue = maskedValue.concat(currMaskChar);
	                
	                if (!currValueChar.equals(currMaskChar)) {
	                	valuePos = valuePos - 1;
	                }
	            }	            
	        }
	        
	        this.maskedValue = maskedValue;
	        this.unMaskedValue = newUnmaskedValue;
        } else {
        	this.maskedValue = this.getUnmaskedValue();
        }
    } 
    
    private static boolean isInteger(String value) {
        try { 
            Integer.parseInt(value); 
        } catch(NumberFormatException e) { 
            return false; 
        }
        // only got here if we didn't return false
        return true;        
    }        
}
