/**
 * 
 */
package com.sms.controls.client;

import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.sms.controls.MaskExtension;
import com.vaadin.client.ComponentConnector;
import com.vaadin.client.ServerConnector;
import com.vaadin.client.extensions.AbstractExtensionConnector;
import com.vaadin.client.ui.VTextField;
import com.vaadin.client.ui.textfield.TextFieldConnector;
import com.vaadin.shared.ui.Connect;

/**
 * @author flb
 *
 */
@SuppressWarnings("serial")
@Connect(MaskExtension.class)
public class MaskConnector extends TextFieldConnector {
	
	private MaskUtility maskUtility = new MaskUtility();
	
	private VTextField textField = null;
	
	KeyUpHandler ku = new KeyUpHandler() {
		@Override
		public void onKeyUp(KeyUpEvent event) {
			Boolean atEnd = false;
			Integer pos = textField.getCursorPos();
			
			if (pos == textField.getText().length()) {
				atEnd = true;
			}
			
			maskUtility.setMask(getState().getMask());
			maskUtility.setUnmaskedValue(textField.getText());
			textField.setValue(maskUtility.getMaskedValue());
			textField.valueChange(true);
			if (atEnd) {
				textField.setCursorPos(textField.getText().length());
			} else {
				textField.setCursorPos(pos);
			}
		}
	};
	
	
	@Override
	public MaskSharedState getState() {
		// TODO Auto-generated method stub
		return (MaskSharedState) super.getState();
	}

	/**
	 * 
	 */
	public MaskConnector() {
	}

	@Override
	protected void init() {
		// TODO Auto-generated method stub
		super.init();
		this.textField = this.getWidget();
		this.textField.addKeyUpHandler(this.ku);		
	}

	
	/* (non-Javadoc)
	 * @see com.vaadin.client.extensions.AbstractExtensionConnector#extend(com.vaadin.client.ServerConnector)
	 */
//	@Override
//	protected void extend(ServerConnector target) {
//		this.textField = this.getWidget();
//		
//		this.textField.addKeyUpHandler(ku);
//	}
}
